/**
 * DocumentRoot.java
 *
 * File generated from the cdaepsos::DocumentRoot uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class DocumentRoot.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DocumentRoot", propOrder = {
	"mixed"
})
@XmlRootElement(name = "DocumentRoot")
public class DocumentRoot implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "xmlns:prefix", type = JAXBElement.class),
			@XmlElementRef(name = "xsi:schemaLocation", type = JAXBElement.class),
			@XmlElementRef(name = "ClinicalDocument", namespace = "urn:hl7-org:v3", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.mixed.add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.mixed.remove(mixed_elt);
	}
	
	/**
	 * Return xMLNSPrefixMap.
	 * @return xMLNSPrefixMap
	 */
	public List<String> getXMLNSPrefixMap() {
		List<String> xMLNSPrefixMap_el = new ArrayList<String>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("xmlns:prefix")){
					xMLNSPrefixMap_el.add( (String) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return xMLNSPrefixMap_el;
	}
	
	public void addXMLNSPrefixMap(String obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<String> jobj = of.createDocumentRootXMLNSPrefixMap(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return xSISchemaLocation.
	 * @return xSISchemaLocation
	 */
	public List<String> getXSISchemaLocation() {
		List<String> xSISchemaLocation_el = new ArrayList<String>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("xsi:schemaLocation")){
					xSISchemaLocation_el.add( (String) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return xSISchemaLocation_el;
	}
	
	public void addXSISchemaLocation(String obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<String> jobj = of.createDocumentRootXSISchemaLocation(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return clinicalDocument.
	 * @return clinicalDocument
	 */
	public net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument getClinicalDocument() {
		net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument clinicalDocument_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("ClinicalDocument")){
					clinicalDocument_el = (net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return clinicalDocument_el;
				}
			}
		} 

	    return clinicalDocument_el;
	}
	
	public void addClinicalDocument(net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument> jobj = of.createDocumentRootClinicalDocument(obj);
		this.getMixed().add(jobj);
	}
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "DocumentRoot").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(DocumentRoot documentRoot, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (documentRoot != null){
   			cvm.validate(documentRoot, location, diagnostic);
			net.ihe.gazelle.cdaepsos.POCDMT000040ClinicalDocument.validateByModule(documentRoot.getClinicalDocument(), location + "/ClinicalDocument", cvm, diagnostic);
    	}
    }

}